<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use App\Models\Texmaster;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\ExportTexMaster;
use App\Imports\ImportTexMaster;
use Auth, DB, Mail, Validator, File, DataTables, Exception;

class TexMasterController extends Controller{
    /** construct */
        public function __construct(){
            $this->middleware('permission:tex_master-create', ['only' => ['create']]);
            $this->middleware('permission:tex_master-edit', ['only' => ['edit']]);
            $this->middleware('permission:tex_master-view', ['only' => ['view']]);
            $this->middleware('permission:tex_master-delete', ['only' => ['delete']]);
        }
    /** construct */

    /** index */
        public function index(Request $request){
            if($request->ajax()){
                $data = Texmaster::where('status','!=','deleted');
                
                return Datatables::of($data)
                        ->addIndexColumn()
                        ->addColumn('action', function($data){
                            $return = '<div class="btn-group">';

                             if(auth()->user()->can('tex_master-view')){
                                $return .= '<a href="'.route('tex_master.view', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                <i class="fa fa-eye"></i>
                                            </a> &nbsp;';
                             }   
                            
                             if(auth()->user()->can('tex_master-edit')){
                                $return .= '<a href="'.route('tex_master.edit', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                <i class="fa fa-pencil"></i>
                                            </a> &nbsp;';
                             }   

                             if (auth()->user()->can('tex_master-delete')) {
                                $return .= '<a href="javascript:;" class="btn btn-default btn-xs dropdown-toggle" data-toggle="dropdown">
                                                    <i class="fa fa-bars"></i>
                                                </a> &nbsp;
                                                <ul class="dropdown-menu">
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="active" data-id="' . base64_encode($data->id) . '">Active</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="inactive" data-id="' . base64_encode($data->id) . '">Inactive</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="deleted" data-id="' . base64_encode($data->id) . '">Deleted</a></li>
                                                </ul>';
                             }

                            $return .= '</div>';

                            return $return;
                        })

                        /*->editColumn('percentage', function ($data) {
                            return $data->percentage."%";
                        })*/
                        ->editColumn('status', function ($data) {
                            if ($data->status == 'active') {
                                return '<span class="badge badge-pill badge-success">Active</span>';
                            } else if ($data->status == 'inactive') {
                                return '<span class="badge badge-pill badge-warning">Inactive</span>';
                            } else if ($data->status == 'deleted') {
                                return '<span class="badge badge-pill badge-danger">Deleted</span>';
                            }
                        })

                        ->rawColumns(['action' ,'percentage' ,'status'])
                        ->filter(function ($query) {
                                if (request()->get('gst', false)) {
                                    $query->where('tex_master.gst', 'like', "%" . request()->get("gst") . "%");
                                }
                                if (request()->get('compensation_cess', false)) {
                                    $query->where('tex_master.compensation_cess', 'like', "%" . request()->get("compensation_cess") . "%");
                                }
                            })
                        ->make(true);
            }
            return view('tex_master.index');
        }
    /** index */

    /** create */
        public function create(Request $request){
            
            return view('tex_master.create');
        }
    /** create */

    /** insert */
        public function insert(Request $request){
            if($request->ajax()) { return true; }


            $crud = [
                'gst' => $request->gst,
                'compensation_cess' => $request->compensation_cess,
                'status' => 'active',
                'created_at' => date('Y-m-d H:i:s'),
                'created_by' => auth()->user()->id,
                'updated_at' => date('Y-m-d H:i:s'),
                'updated_by' => auth()->user()->id
            ];

            $last_id = Texmaster::insertGetId($crud);

            if ($last_id) {
                return redirect()->route('tex_master')->with(['success' => 'Record inserted successfully']);
            } else {
                return redirect()->back()->with(['error'=>'Faild to insert Record!'])->withInput();
            }
        
        }
    /** insert */

    /** view */
        public function view(Request $request){
            $id = base64_decode($request->id);
            $data = Texmaster::where(['id' => $id])->first();
            
            return view('tex_master.view')->with(['data'=>$data]);
        }
    /** view */
    
    /** edit */
        public function edit(Request $request){
            $id = base64_decode($request->id);
            $data = Texmaster::where(['id' => $id])->first();
           
            return view('tex_master.edit')->with(['data'=>$data]);
        }
    /** edit */

    /** update */
        public function update(Request $request){
            if($request->ajax()){ return true; }
            $id = $request->id;
            
            $crud = [
                'gst' => $request->gst,
                'compensation_cess' => $request->compensation_cess,      
                'updated_at' => date('Y-m-d H:i:s'),
                'updated_by' => auth()->user()->id
            ];

           DB::enableQueryLog();
            $update = Texmaster::where(['id' => $id])->update($crud);
           ;
            if ($update){
                return redirect()->route('tex_master')->with(['success' => 'Record updated successfully']);
            }else{
                return redirect()->back()->with(['error'=>'Faild to update Record!'])->withInput();
            }
        }
    /** update */

    /** change-status */
        public function change_status(Request $request){
            if (!$request->ajax()) { exit('No direct script access allowed'); }
            $id = base64_decode($request->id);
            
            $data = Texmaster::where(['id' => $id])->first();

            if (!empty($data)) {
                $update = Texmaster::where(['id' => $id])->update(['status' => $request->status, 'updated_at' => date('Y-m-d H:i:s'), 'updated_by' => auth('sanctum')->user()->id]);
                if ($update) {
                    return response()->json(['code' => 200]);
                } else {
                    return response()->json(['code' => 201]);
                }
            } else {
                return response()->json(['code' => 201]);
            }
           
        }
    /** change-status */

    /** Import */
        public function import(Request $request){
            $import = Excel::import(new ImportTexMaster(), $request->file('file'));    
            if($import){
                Excel::store(new ImportTexMaster(), 'TexMaster_'.Date('YmdHis').'.xlsx' ,'excel_import');
                return redirect()->route('tex_master')->with('sucess' ,'File Imported Sucessfully');
            }
        }
    /** Import */

    /** Export */
        public function export(Request $request){
            $slug = $request->slug;
            $name = 'TexMaster_'.Date('YmdHis').'.xlsx';
    
            try {
                return Excel::download(new ExportTexMaster($slug), $name);
            }catch(\Exception $e){
                return redirect()->back()->with('error', $e->getMessage());
            }
        }
    /** Export */

   
}
